// Code generated by mockery v2.10.2. DO NOT EDIT.

package mocks

import (
	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/aquix/ms-generator/tree/models"

	ms_sharedmodels "gitlab.com/nikita.morozov/ms-shared/models"
)

// EntityUseCases is an autogenerated mock type for the EntityUseCases type
type EntityUseCases struct {
	mock.Mock
}

// Count provides a mock function with given fields:
func (_m *EntityUseCases) Count() (int64, error) {
	ret := _m.Called()

	var r0 int64
	if rf, ok := ret.Get(0).(func() int64); ok {
		r0 = rf()
	} else {
		r0 = ret.Get(0).(int64)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Create provides a mock function with given fields: item
func (_m *EntityUseCases) Create(item *models.Entity) error {
	ret := _m.Called(item)

	var r0 error
	if rf, ok := ret.Get(0).(func(*models.Entity) error); ok {
		r0 = rf(item)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// Delete provides a mock function with given fields: id
func (_m *EntityUseCases) Delete(id uint64) error {
	ret := _m.Called(id)

	var r0 error
	if rf, ok := ret.Get(0).(func(uint64) error); ok {
		r0 = rf(id)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetById provides a mock function with given fields: id
func (_m *EntityUseCases) GetById(id uint64) (*models.Entity, error) {
	ret := _m.Called(id)

	var r0 *models.Entity
	if rf, ok := ret.Get(0).(func(uint64) *models.Entity); ok {
		r0 = rf(id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Entity)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint64) error); ok {
		r1 = rf(id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetBySlug provides a mock function with given fields: slug
func (_m *EntityUseCases) GetBySlug(slug string) (*models.Entity, error) {
	ret := _m.Called(slug)

	var r0 *models.Entity
	if rf, ok := ret.Get(0).(func(string) *models.Entity); ok {
		r0 = rf(slug)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Entity)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(string) error); ok {
		r1 = rf(slug)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetByType provides a mock function with given fields: typeValue
func (_m *EntityUseCases) GetByType(typeValue string) (*models.Entity, error) {
	ret := _m.Called(typeValue)

	var r0 *models.Entity
	if rf, ok := ret.Get(0).(func(string) *models.Entity); ok {
		r0 = rf(typeValue)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Entity)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(string) error); ok {
		r1 = rf(typeValue)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ListByParentId provides a mock function with given fields: parentId, opts
func (_m *EntityUseCases) ListByParentId(parentId *uint64, opts ms_sharedmodels.ListOptions) (*[]models.Entity, *ms_sharedmodels.Paginator, error) {
	ret := _m.Called(parentId, opts)

	var r0 *[]models.Entity
	if rf, ok := ret.Get(0).(func(*uint64, ms_sharedmodels.ListOptions) *[]models.Entity); ok {
		r0 = rf(parentId, opts)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*[]models.Entity)
		}
	}

	var r1 *ms_sharedmodels.Paginator
	if rf, ok := ret.Get(1).(func(*uint64, ms_sharedmodels.ListOptions) *ms_sharedmodels.Paginator); ok {
		r1 = rf(parentId, opts)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*ms_sharedmodels.Paginator)
		}
	}

	var r2 error
	if rf, ok := ret.Get(2).(func(*uint64, ms_sharedmodels.ListOptions) error); ok {
		r2 = rf(parentId, opts)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// Update provides a mock function with given fields: item
func (_m *EntityUseCases) Update(item *models.Entity) (*models.Entity, error) {
	ret := _m.Called(item)

	var r0 *models.Entity
	if rf, ok := ret.Get(0).(func(*models.Entity) *models.Entity); ok {
		r0 = rf(item)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Entity)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(*models.Entity) error); ok {
		r1 = rf(item)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}
